unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, SNMPsend, StdCtrls, ExtCtrls, ComCtrls,
  GIFImage, StrUtils, CoolTrayIcon, Registry;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Timer1: TTimer;
    Panel1: TPanel;
    Image1: TImage;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    lblIP: TLabel;
    lblOID1: TLabel;
    edtOID1: TEdit;
    lblCommunity: TLabel;
    edtCommunity: TEdit;
    lblOID2: TLabel;
    edtOID2: TEdit;
    lblMaximum: TLabel;
    edtMax: TEdit;
    lblBytes: TLabel;
    edtIP: TEdit;
    grpOID1: TGroupBox;
    grpOID2: TGroupBox;
    shpOID1: TShape;
    btnOID1: TButton;
    cdialOID: TColorDialog;
    shpOID2: TShape;
    btnOID2: TButton;
    chkFullOID1: TCheckBox;
    chkFullOID2: TCheckBox;
    edtTextSize: TEdit;
    lblTxtSize: TLabel;
    chkSaveGIF: TCheckBox;
    edtXOID1: TEdit;
    edtYOID1: TEdit;
    lblXOID1: TLabel;
    lblYOID1: TLabel;
    edtXOID2: TEdit;
    edtYOID2: TEdit;
    lblXOID2: TLabel;
    lblYOID2: TLabel;
    lblTextOID1: TLabel;
    lblTextOID2: TLabel;
    udTextSize: TUpDown;
    TabSheet4: TTabSheet;
    lblp1: TLabel;
    edtP1: TEdit;
    edtP2: TEdit;
    lblp2: TLabel;
    lblp3: TLabel;
    edtP3: TEdit;
    edtP4: TEdit;
    lblp4: TLabel;
    chkTxt1: TCheckBox;
    edtTXT1: TEdit;
    edtTXT1X: TEdit;
    edtTXT1Y: TEdit;
    lblTXT1X: TLabel;
    lblTXT1Y: TLabel;
    chkTxt2: TCheckBox;
    edtTXT2: TEdit;
    edtTXT2X: TEdit;
    lblTXT2X: TLabel;
    edtTXT2Y: TEdit;
    lblTXT2Y: TLabel;
    chkTxt3: TCheckBox;
    edtTXT3: TEdit;
    edtTXT3X: TEdit;
    lblTXT3X: TLabel;
    edtTXT3Y: TEdit;
    lblTXT3Y: TLabel;
    chkTxt4: TCheckBox;
    edtTXT4: TEdit;
    edtTXT4X: TEdit;
    lblTXT4X: TLabel;
    edtTXT4Y: TEdit;
    lblTXT4Y: TLabel;
    cbp1Time: TComboBox;
    cbp2Time: TComboBox;
    cbp3Time: TComboBox;
    cbp4Time: TComboBox;
    lblGraphCoord: TLabel;
    edtGTX: TEdit;
    lblGTX: TLabel;
    edtGTY: TEdit;
    lblGTY: TLabel;
    edtGBX: TEdit;
    lblGBX: TLabel;
    edtGBY: TEdit;
    lblGBY: TLabel;
    chkVticks: TCheckBox;
    chkHticks: TCheckBox;
    chkTotal: TCheckBox;
    edtTotalX: TEdit;
    Label2: TLabel;
    edtTotalY: TEdit;
    Label3: TLabel;
    CoolTrayIcon1: TCoolTrayIcon;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Button2: TButton;
    Button3: TButton;
    Edit9: TEdit;
    Edit8: TEdit;
    Edit7: TEdit;
    lblp5: TLabel;
    edtP5: TEdit;
    cbp5Time: TComboBox;
    chkTxt5: TCheckBox;
    edtTXT5: TEdit;
    edtTXT5X: TEdit;
    lblTXT5X: TLabel;
    edtTXT5Y: TEdit;
    lblTXT5Y: TLabel;
    lblRefresh: TLabel;
    edtRefresh: TEdit;
    lblRefS: TLabel;
    lblTickFreq: TLabel;
    edtTickFreq: TEdit;
    lblTickMin: TLabel;
    chkGLabel: TCheckBox;
    TabSheet5: TTabSheet;
    Label1: TLabel;
    Label4: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure btnOID1Click(Sender: TObject);
    procedure btnOID2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CoolTrayIcon1DblClick(Sender: TObject);
    procedure edtRefreshChange(Sender: TObject);
  private
    { Private declarations }
    procedure SaveSettings;
    procedure LoadSettings;
    procedure DrawGraph;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  NotFirstVal: Boolean;
  Lup, Ldo : Integer;
  s1,s2,s3,s4,s5 : String;
  DrawBitmap: TBitmap;

Function TTTT(TT : Int64): String; // TimeTicksToTime


implementation

{$R *.DFM}

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  DrawGraph();
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  NotFirstVal := False;
  Timer1.Enabled := true;
  Button3.Enabled := true;
  Button2.Enabled := false;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Timer1.Enabled := false;
  Button3.Enabled := false;
  Button2.Enabled := true;
end;

procedure TForm1.btnOID1Click(Sender: TObject);
begin
  cdialOID.Color := shpOID1.Brush.Color;
  if cdialOID.Execute then
    shpOID1.Brush.Color := cdialOID.Color;
end;

procedure TForm1.btnOID2Click(Sender: TObject);
begin
  cdialOID.Color := shpOID2.Brush.Color;
  if cdialOID.Execute then
    shpOID2.Brush.Color := cdialOID.Color;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  Ico : TIcon;
begin
  LoadSettings;

  PageControl1.ActivePageIndex := 0;
  Button2.Click;;
  DrawBitmap := TBitmap.Create;
  DrawBitmap.Width := 16;
  DrawBitmap.Height := 16;
  DrawBitmap.Canvas.Brush.Color := clWhite;
  DrawBitmap.Canvas.FillRect(Rect(0,0,16,16));
  if chkHticks.State = cbChecked then
  begin
    DrawBitmap.Canvas.Pen.Color := clGray;
    DrawBitmap.Canvas.MoveTo(0,0);
    DrawBitmap.Canvas.LineTo(16,0);
    DrawBitmap.Canvas.MoveTo(0,15);
    DrawBitmap.Canvas.LineTo(16,15);
  end;

  Ico := TIcon.Create;
  try
    if CoolTrayIcon1.BitmapToIcon(DrawBitmap, Ico, clWhite) then
    begin
      CoolTrayIcon1.Icon.Assign(Ico);
      CoolTrayIcon1.Refresh;
    end;
  finally
    Ico.Free;
  end;

  DrawGraph();

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Button3.Click;
  SaveSettings;
  DrawBitmap.Free;
end;

procedure TForm1.CoolTrayIcon1DblClick(Sender: TObject);
begin
  CoolTrayIcon1.ShowMainForm;
  Form1.Show;
  Form1.SetFocus;
end;

procedure TForm1.SaveSettings;
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Reg.OpenKey('\Software\FCC\SRG', True) then
    begin
      Reg.WriteString('Version','0.9.5');

      Reg.WriteString('Monitored IP',edtIP.Text);
      Reg.WriteString('Community',edtCommunity.Text);
      Reg.WriteString('OID 1',edtOID1.Text);
      Reg.WriteString('OID 2',edtOID2.Text);
      Reg.WriteString('P1',edtP1.Text);
      Reg.WriteString('P2',edtP2.Text);
      Reg.WriteString('P3',edtP3.Text);
      Reg.WriteString('P4',edtP4.Text);
      Reg.WriteString('Ptype1',cbp1Time.Text);
      Reg.WriteString('Ptype2',cbp2Time.Text);
      Reg.WriteString('Ptype3',cbp3Time.Text);
      Reg.WriteString('Ptype4',cbp4Time.Text);

      Reg.WriteString('Maximum',edtMax.Text);
      Reg.WriteInteger('Text size',udTextSize.Position);
      Reg.WriteBool('Save To Gif',chkSaveGIF.Checked);
      Reg.WriteString('OIDcolor1',ColorToString(shpOID1.Brush.Color));
      Reg.WriteBool('OIDfull1',chkFullOID1.Checked);
      Reg.WriteString('OIDtextX1',edtXOID1.Text);
      Reg.WriteString('OIDtextY1',edtYOID1.Text);
      Reg.WriteString('OIDcolor2',ColorToString(shpOID2.Brush.Color));
      Reg.WriteBool('OIDfull2',chkFullOID2.Checked);
      Reg.WriteString('OIDtextX2',edtXOID2.Text);
      Reg.WriteString('OIDtextY2',edtYOID2.Text);
      Reg.WriteString('GraphTX',edtGTX.Text);
      Reg.WriteString('GraphTY',edtGTY.Text);
      Reg.WriteString('GraphBX',edtGBX.Text);
      Reg.WriteString('GraphBY',edtGBY.Text);
      Reg.WriteBool('Vertical Ticks',chkVticks.Checked);
      Reg.WriteBool('Horizontal Ticks',chkHticks.Checked);
      Reg.WriteBool('Total up down',chkTotal.Checked);
      Reg.WriteString('Total Text X',edtTotalX.Text);
      Reg.WriteString('Total Text Y',edtTotalY.Text);

      Reg.WriteBool('ShowText1',chkTxt1.Checked);
      Reg.WriteString('Total Text1',edtTXT1.Text);
      Reg.WriteString('Total TextX1',edtTXT1X.Text);
      Reg.WriteString('Total TextY1',edtTXT1Y.Text);
      Reg.WriteBool('ShowText2',chkTxt2.Checked);
      Reg.WriteString('Total Text2',edtTXT2.Text);
      Reg.WriteString('Total TextX2',edtTXT2X.Text);
      Reg.WriteString('Total TextY2',edtTXT2Y.Text);
      Reg.WriteBool('ShowText3',chkTxt3.Checked);
      Reg.WriteString('Total Text3',edtTXT3.Text);
      Reg.WriteString('Total TextX3',edtTXT3X.Text);
      Reg.WriteString('Total TextY3',edtTXT3Y.Text);
      Reg.WriteBool('ShowText4',chkTxt4.Checked);
      Reg.WriteString('Total Text4',edtTXT4.Text);
      Reg.WriteString('Total TextX4',edtTXT4X.Text);
      Reg.WriteString('Total TextY4',edtTXT4Y.Text);

      Reg.WriteBool('ShowText5',chkTxt5.Checked);
      Reg.WriteString('Total Text5',edtTXT5.Text);
      Reg.WriteString('Total TextX5',edtTXT5X.Text);
      Reg.WriteString('Total TextY5',edtTXT5Y.Text);

      Reg.WriteString('Refresh',edtRefresh.Text);
      Reg.WriteString('TickFreq',edtTickFreq.Text);

      Reg.WriteBool('Graph Label',chkGLabel.Checked);

      Reg.WriteInteger('WindowsTop',Form1.Top);
      Reg.WriteInteger('WindowsLeft',Form1.Left);

      Reg.WriteFloat('VersionNum',0.96);

      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
end;

procedure TForm1.LoadSettings;
var
  Reg: TRegistry;
  v : String;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Reg.OpenKey('\Software\FCC\SRG', True) then
    begin
      if not Reg.ValueExists('Version') then Exit;

      edtIP.Text := Reg.ReadString('Monitored IP');
      edtCommunity.Text := Reg.ReadString('Community');
      edtOID1.Text := Reg.ReadString('OID 1');
      edtOID2.Text := Reg.ReadString('OID 2');
      edtP1.Text := Reg.ReadString('P1');
      edtP2.Text := Reg.ReadString('P2');
      edtP3.Text := Reg.ReadString('P3');
      edtP4.Text := Reg.ReadString('P4');
      cbp1Time.Text := Reg.ReadString('Ptype1');
      cbp2Time.Text := Reg.ReadString('Ptype2');
      cbp3Time.Text := Reg.ReadString('Ptype3');
      cbp4Time.Text := Reg.ReadString('Ptype4');

      edtMax.Text := Reg.ReadString('Maximum');
      udTextSize.Position := Reg.ReadInteger('Text size');
      chkSaveGIF.Checked := Reg.ReadBool('Save To Gif');
      shpOID1.Brush.Color := StringToColor(Reg.ReadString('OIDcolor1'));
      chkFullOID1.Checked := Reg.ReadBool('OIDfull1');
      edtXOID1.Text := Reg.ReadString('OIDtextX1');
      edtYOID1.Text := Reg.ReadString('OIDtextY1');
      shpOID2.Brush.Color := StringToColor(Reg.ReadString('OIDcolor2'));
      chkFullOID2.Checked := Reg.ReadBool('OIDfull2');
      edtXOID2.Text := Reg.ReadString('OIDtextX2');
      edtYOID2.Text := Reg.ReadString('OIDtextY2');
      edtGTX.Text := Reg.ReadString('GraphTX');
      edtGTY.Text := Reg.ReadString('GraphTY');
      edtGBX.Text := Reg.ReadString('GraphBX');
      edtGBY.Text := Reg.ReadString('GraphBY');
      chkVticks.Checked := Reg.ReadBool('Vertical Ticks');
      chkHticks.Checked := Reg.ReadBool('Horizontal Ticks');
      chkTotal.Checked := Reg.ReadBool('Total up down');
      edtTotalX.Text := Reg.ReadString('Total Text X');
      edtTotalY.Text := Reg.ReadString('Total Text Y');

      chkTxt1.Checked := Reg.ReadBool('ShowText1');
      edtTXT1.Text := Reg.ReadString('Total Text1');
      edtTXT1X.Text := Reg.ReadString('Total TextX1');
      edtTXT1Y.Text := Reg.ReadString('Total TextY1');
      chkTxt2.Checked := Reg.ReadBool('ShowText2');
      edtTXT2.Text := Reg.ReadString('Total Text2');
      edtTXT2X.Text := Reg.ReadString('Total TextX2');
      edtTXT2Y.Text := Reg.ReadString('Total TextY2');
      chkTxt3.Checked := Reg.ReadBool('ShowText3');
      edtTXT3.Text := Reg.ReadString('Total Text3');
      edtTXT3X.Text := Reg.ReadString('Total TextX3');
      edtTXT3Y.Text := Reg.ReadString('Total TextY3');
      chkTxt4.Checked := Reg.ReadBool('ShowText4');
      edtTXT4.Text := Reg.ReadString('Total Text4');
      edtTXT4X.Text := Reg.ReadString('Total TextX4');
      edtTXT4Y.Text := Reg.ReadString('Total TextY4');
      if Reg.ReadString('Version') = '0.9.5' then
      begin
        chkTxt5.Checked := Reg.ReadBool('ShowText5');
        edtTXT5.Text := Reg.ReadString('Total Text5');
        edtTXT5X.Text := Reg.ReadString('Total TextX5');
        edtTXT5Y.Text := Reg.ReadString('Total TextY5');

        edtRefresh.Text := Reg.ReadString('Refresh');
        edtTickFreq.Text := Reg.ReadString('TickFreq');

        chkGLabel.Checked := Reg.ReadBool('Graph Label');

        if Reg.ValueExists('VersionNum') then
          if Reg.ReadFloat('VersionNum') >= 0.96 then
          begin

          end;
      end;

      Form1.Top := Reg.ReadInteger('WindowsTop');
      Form1.Left := Reg.ReadInteger('WindowsLeft');

      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
end;

Function TTTT(TT : Int64): String; // TimeTicksToTime
var
  T,T2 : Int64;
  S : String;
begin
    T := TT div 100;
    // 1 min = 60 s
    // 1 hou = 3600 s
    // 1 day = 86400 s

    S := IntToStr(T div 86400) + ' Days ';
    T := (T-((T div 86400)*86400));
    S := S + IntToStr(T div 3600) + 'h';
    T := (T-((T div 3600)*3600));
    T2 := T div 60;
    if length(IntToStr(T2)) = 1 then S := S + '0';
    S := S + IntToStr(T2) + 'm';
    T := (T-((T div 60)*60));
    if length(IntToStr(T)) = 1 then S := S + '0';
    S := S + IntToStr(T) + 's';

    TTTT := S;
end;

procedure TForm1.edtRefreshChange(Sender: TObject);
begin
  if StrToInt(edtRefresh.Text) > 1 then
  begin
//    Button3.Click;
    Timer1.Interval := StrToInt(edtRefresh.Text)*1000;
//    Button2.Click;
  end
  else
    edtRefresh.Text := '1';
end;

procedure TForm1.DrawGraph();
var
  response,s : string;
  Bv, BvR, t, i : integer;
  gf: TGifImage;
  p1, p2, p3, p4, p5 : String;
  MyRect, MyOther,M1,M2,MT: TRect;
  MyICORect, MyICOOther: TRect;
  MaxBytes, MaxBytesIcon : Integer;
  MaxGraph, MaxGraphIcon : Integer;
  Hour, Min, Sec, MSec: Word;
  Ico: TIcon;
  b,b1 : Boolean;
begin

  MyRect := Rect(StrToInt(edtGTX.text),StrToInt(edtGTY.text),StrToInt(edtGBX.text),StrToInt(edtGBY.text));
  MyOther := Rect(MyRect.Left+1,MyRect.Top,MyRect.Right,MyRect.Bottom);

  Image1.Canvas.Font.Size := udTextSize.Position;
  Image1.Canvas.Font.Name := 'Arial';

  MaxGraph := (StrToInt(edtGBY.text)-StrToInt(edtGTY.text));
  MaxBytes := StrToInt(edtMax.Text) div MaxGraph;
  MaxGraphIcon := 16;
  MaxBytesIcon := StrToInt(edtMax.Text) div MaxGraphIcon;

  if chkGLabel.Checked then
  begin
    s := IntToStr(StrToInt(edtMax.Text) div 1000) +  'kB';
    t := Image1.Canvas.TextWidth(s)+3;
    Image1.Canvas.Font.Color := clDkGray;
    Image1.Canvas.TextOut(1+MyRect.Left,MyRect.Top,s);
    s := IntToStr(3*(StrToInt(edtMax.Text) div 1000) div 4) +  'kB';
    Image1.Canvas.TextOut(1+MyRect.Left,MyRect.Top+ 1*(MaxGraph div 4),s);
    s := IntToStr(2*(StrToInt(edtMax.Text) div 1000) div 4) +  'kB';
    Image1.Canvas.TextOut(1+MyRect.Left,MyRect.Top+ 2*(MaxGraph div 4),s);
    s := IntToStr(1*(StrToInt(edtMax.Text) div 1000) div 4) +  'kB';
    Image1.Canvas.TextOut(1+MyRect.Left,MyRect.Top+ 3*(MaxGraph div 4),s);
    MyRect := Rect(MyRect.Left+t,MyRect.Top,MyRect.Right,MyRect.Bottom);
    MyOther := Rect(MyOther.Left+t,MyOther.Top,MyOther.Right,MyOther.Bottom);
    Image1.Canvas.Pen.Color := clDkGray;
    Image1.Canvas.MoveTo(MyRect.Left-1,MyRect.Top);
    Image1.Canvas.LineTo(MyRect.Left-1,MyRect.Bottom);
  end;

  Image1.Canvas.Refresh;

  s := FloatToStr(Round((Ldo div 10)/ 10.24)/10) + ' kB/s';
  M1 := Rect(StrToInt(edtXOID1.text),StrToInt(edtYOID1.text),StrToInt(edtXOID1.text)+Image1.Canvas.TextWidth(s),StrToInt(edtYOID1.text)+Image1.Canvas.TextHeight(s));
  s := FloatToStr(Round((Lup div 10)/ 10.24)/10) + ' kB/s';
  M2 := Rect(StrToInt(edtXOID2.text),StrToInt(edtYOID2.text),StrToInt(edtXOID2.text)+Image1.Canvas.TextWidth(s),StrToInt(edtYOID2.text)+Image1.Canvas.TextHeight(s));

  Image1.Canvas.CopyRect(MyOther,Image1.Canvas,MyRect);
  DecodeTime(Now,Hour,Min,Sec,MSec);

  MyICORect := Rect(0,0,16,16);
  MyICOOther := Rect(1,0,16,16);

  DrawBitmap.Canvas.CopyRect(MyICOOther,DrawBitmap.Canvas,MyICORect);
  DrawBitmap.Canvas.Pen.Color := clWhite;
  DrawBitmap.Canvas.MoveTo(0,0);
  DrawBitmap.Canvas.LineTo(0,16);

  t := Min mod StrToInt(edtTickFreq.Text);
  b  := (Sec = 0) AND (StrToInt(edtTickFreq.Text) = 1 );
  b1 := (StrToInt(edtTickFreq.Text) > 1 ) AND (t = 0);

  if (chkVticks.State = cbChecked) AND (not NotFirstVal) then
  begin
    Image1.Canvas.Pen.Color := clLtGray;
    for i := MyRect.Left to MyRect.Right do
    begin
      if (StrToInt(edtTickFreq.Text) = 1 ) then
        t := ((i-Sec-MyRect.Left) mod 60)
      else
        t := ((i-Min-MyRect.Left) mod StrToInt(edtTickFreq.Text));

      if t = 0 then
      begin
        Image1.Canvas.MoveTo(i,MyRect.Top);
        Image1.Canvas.LineTo(i,MyRect.Bottom);
      end;
    end;
  end;

  if (chkVticks.State = cbChecked) AND (b or b1) then
    Image1.Canvas.Pen.Color := clLtGray
  else
    Image1.Canvas.Pen.Color := clWhite;

  Image1.Canvas.MoveTo(MyRect.Left,MyRect.Top);
  Image1.Canvas.LineTo(MyRect.Left,MyRect.Bottom);

  if chkHticks.State = cbChecked then
  begin
    Image1.Canvas.Pen.Color := clLtGray;
    if NotFirstVal then
    begin
      Image1.Canvas.MoveTo(MyRect.Left  ,MyRect.Top);
      Image1.Canvas.LineTo(MyRect.Left-1,MyRect.Top);
      Image1.Canvas.MoveTo(MyRect.Left  ,MyRect.Top+ 1*(MaxGraph div 4));
      Image1.Canvas.LineTo(MyRect.Left-1,MyRect.Top+ 1*(MaxGraph div 4));
      Image1.Canvas.MoveTo(MyRect.Left  ,MyRect.Top+ 2*(MaxGraph div 4));
      Image1.Canvas.LineTo(MyRect.Left-1,MyRect.Top+ 2*(MaxGraph div 4));
      Image1.Canvas.MoveTo(MyRect.Left  ,MyRect.Top+ 3*(MaxGraph div 4));
      Image1.Canvas.LineTo(MyRect.Left-1,MyRect.Top+ 3*(MaxGraph div 4));
      Image1.Canvas.MoveTo(MyRect.Left  ,MyRect.Bottom);
      Image1.Canvas.LineTo(MyRect.Left-1,MyRect.Bottom);
    end
    else
    begin
      Image1.Canvas.MoveTo(MyRect.Left ,MyRect.Top);
      Image1.Canvas.LineTo(MyRect.Right,MyRect.Top);
      Image1.Canvas.MoveTo(MyRect.Left ,MyRect.Top+ 1*(MaxGraph div 4));
      Image1.Canvas.LineTo(MyRect.Right,MyRect.Top+ 1*(MaxGraph div 4));
      Image1.Canvas.MoveTo(MyRect.Left ,MyRect.Top+ 2*(MaxGraph div 4));
      Image1.Canvas.LineTo(MyRect.Right,MyRect.Top+ 2*(MaxGraph div 4));
      Image1.Canvas.MoveTo(MyRect.Left ,MyRect.Top+ 3*(MaxGraph div 4));
      Image1.Canvas.LineTo(MyRect.Right,MyRect.Top+ 3*(MaxGraph div 4));
      Image1.Canvas.MoveTo(MyRect.Left ,MyRect.Bottom);
      Image1.Canvas.LineTo(MyRect.Right,MyRect.Bottom);
    end;

    DrawBitmap.Canvas.Pen.Color := clGray;
    DrawBitmap.Canvas.MoveTo(0,0);
    DrawBitmap.Canvas.LineTo(-1,0);
    DrawBitmap.Canvas.MoveTo(0,15);
    DrawBitmap.Canvas.LineTo(-1,15);
  end;

  Image1.Canvas.Pen.Color := clWhite;
  Image1.Canvas.Rectangle(M1);
  Image1.Canvas.Rectangle(M2);

  if SNMPget(edtOID1.Text,edtCommunity.Text,edtIP.Text,response) then
  begin
        Edit5.Text := Edit4.Text;
        Edit4.Text := response;

        if not NotFirstVal then Edit5.Text := Edit4.Text;

        s := IntToStr(StrToInt64(Edit4.Text)-StrToInt64(Edit5.Text));
        Bv := StrToInt(s) div StrToInt(edtRefresh.Text);

        Edit6.Text := IntToStr(Bv);
        BvR := Bv div MaxBytes;
        if Bvr > MaxGraph then
        begin
          Image1.Canvas.Pen.Color := shpOID1.Brush.Color;
          Bvr := MaxGraph;
        end
        else
          Image1.Canvas.Pen.Color := shpOID1.Brush.Color;

        if NotFirstVal then
        begin
          if chkFullOID1.State = cbChecked then
            Image1.Canvas.MoveTo(MyRect.Left,MyRect.Bottom)
          else
            Image1.Canvas.MoveTo(MyRect.Left+1,MyRect.Bottom-(Ldo div MaxBytes));
          Image1.Canvas.LineTo(MyRect.Left,MyRect.Bottom-BvR);
          s := FloatToStr(Round((Bv div 10)/ 10.24)/10) + ' kB/s';
          Image1.Canvas.Font.Color := shpOID1.Brush.Color;
          Image1.Canvas.TextOut(StrToInt(edtXOID1.text),StrToInt(edtYOID1.text),s);

          BvR := Bv div MaxBytesIcon;
          if Bvr > MaxGraphIcon then Bvr := MaxGraphIcon;

          DrawBitmap.Canvas.Pen.Color := shpOID1.Brush.Color;

          if chkFullOID1.State = cbChecked then
            DrawBitmap.Canvas.MoveTo(0,15)
          else
            DrawBitmap.Canvas.MoveTo(1,15-(Ldo div MaxBytesIcon));
          DrawBitmap.Canvas.LineTo(0,15-BvR);
          Ldo := Bv;
        end;
  end;

  if SNMPget(edtOID2.Text,edtCommunity.Text,edtIP.Text,response) then
  begin
        Edit8.Text := Edit7.Text;
        Edit7.Text := response;
        if not NotFirstVal then Edit8.Text := Edit7.Text;

        s := IntToStr(StrToInt64(Edit7.Text)-StrToInt64(Edit8.Text));
        Bv := StrToInt(s) div StrToInt(edtRefresh.Text);
        Edit9.Text := IntToStr(Bv);

        BvR := Bv div MaxBytes;
        if Bvr > MaxGraph then
        begin
          Image1.Canvas.Pen.Color := shpOID2.Brush.Color;
          Bvr := MaxGraph;
        end
        else
          Image1.Canvas.Pen.Color := shpOID2.Brush.Color;

        if NotFirstVal then
        begin
          if chkFullOID2.State = cbChecked then
            Image1.Canvas.MoveTo(MyRect.Left,MyRect.Bottom)
          else
            Image1.Canvas.MoveTo(MyRect.Left+1,MyRect.Bottom-(Lup div MaxBytes));
          Image1.Canvas.LineTo(MyRect.Left,MyRect.Bottom-BvR);

          BvR := Bv div MaxBytesIcon;
          if Bvr > MaxGraphIcon then Bvr := MaxGraphIcon;

          DrawBitmap.Canvas.Pen.Color := shpOID2.Brush.Color;

          if chkFullOID2.State = cbChecked then
            DrawBitmap.Canvas.MoveTo(0,15)
          else
            DrawBitmap.Canvas.MoveTo(1,15-(Lup div MaxBytesIcon));
          DrawBitmap.Canvas.LineTo(0,16-BvR);

          s := FloatToStr(Round((Bv div 10)/ 10.24)/10) + ' kB/s';
          Image1.Canvas.Font.Color := shpOID2.Brush.Color;
          Image1.Canvas.TextOut(StrToInt(edtXOID2.text),StrToInt(edtYOID2.text),s);
          Lup := Bv;
        end;
  end;

  if chkTotal.State = cbChecked then
  begin
    s := 'Down ' + IntToStr(StrToInt64(Edit4.Text) div 1048576) + 'MB';
    Image1.Canvas.Font.Color := shpOID1.Brush.Color;
    t := StrToInt(edtTotalX.text);
    Image1.Canvas.TextOut(t,StrToInt(edtTotalY.text),s);
    Image1.Canvas.Font.Color := clBlack;
    t := t + Image1.Canvas.TextWidth(s);
    s := ' / ';
    Image1.Canvas.TextOut(t,StrToInt(edtTotalY.text),s);
    Image1.Canvas.Font.Color := shpOID2.Brush.Color;
    t := t + Image1.Canvas.TextWidth(s);
    s := 'Up ' + IntToStr(StrToInt64(Edit8.Text) div 1048576) + 'MB';
    Image1.Canvas.TextOut(t,StrToInt(edtTotalY.text),s);
  end;

  if SNMPget(edtP1.Text,edtCommunity.Text,edtIP.Text,response) then
  begin
    p1 := response;
    if cbp1Time.Text = 'Time' then p1 := TTTT(StrToInt64(p1));
  end
  else
    p1 := 'N/A';

  if SNMPget(edtP2.Text,edtCommunity.Text,edtIP.Text,response) then
  begin
    p2 := response;
    if cbp2Time.Text = 'Time' then p2 := TTTT(StrToInt64(p2));
  end
  else
    p2 := 'N/A';

  if SNMPget(edtP3.Text,edtCommunity.Text,edtIP.Text,response) then
  begin
    p3 := response;
    if cbp3Time.Text = 'Time' then p3 := TTTT(StrToInt64(p3));
  end
  else
    p3 := 'N/A';

  if SNMPget(edtP4.Text,edtCommunity.Text,edtIP.Text,response) then
  begin
    p4 := response;
    if cbp4Time.Text = 'Time' then p4 := TTTT(StrToInt64(p4));
    if cbp4Time.Text = 'NextAdp' then
    begin
      s := edtP4.Text + '.' + edtIP.text;
      if SNMPgetNext(s,edtCommunity.Text,edtIP.Text,response) then
        s := response;
        t := Length(s)-Length(edtP4.Text)-1;
        s := Copy(s,Length(edtP4.Text)+2,t);
        p4 := s;
    end;
  end
  else
    p4 := 'N/A';

  if SNMPget(edtP5.Text,edtCommunity.Text,edtIP.Text,response) then
  begin
    p5 := response;
    if cbp5Time.Text = 'Time' then p5 := TTTT(StrToInt64(p5));
  end
  else
    p5 := 'N/A';


  if chkTxt1.State = cbChecked then
  begin
    s := s1;
    MT := Rect(StrToInt(edtTXT1X.text),StrToInt(edtTXT1Y.text),StrToInt(edtTXT1X.text)+Image1.Canvas.TextWidth(s),StrToInt(edtTXT1Y.text)+Image1.Canvas.TextHeight(s));
    s := edtTXT1.Text;
    s := AnsiReplaceStr(s,'%1',p1);
    s := AnsiReplaceStr(s,'%2',p2);
    s := AnsiReplaceStr(s,'%3',p3);
    s := AnsiReplaceStr(s,'%4',p4);
    s := AnsiReplaceStr(s,'%5',p5);
    s1 := s;
    Image1.Canvas.Pen.Color := clWhite;
    Image1.Canvas.Rectangle(MT);
    Image1.Canvas.Font.Color := clBlack;
    Image1.Canvas.TextOut(StrToInt(edtTXT1X.text),StrToInt(edtTXT1Y.text),s);
  end;

  if chkTxt2.State = cbChecked then
  begin
    s := s2;
    MT := Rect(StrToInt(edtTXT2X.text),StrToInt(edtTXT2Y.text),StrToInt(edtTXT2X.text)+Image1.Canvas.TextWidth(s),StrToInt(edtTXT2Y.text)+Image1.Canvas.TextHeight(s));
    s := edtTXT2.Text;
    s := AnsiReplaceStr(s,'%1',p1);
    s := AnsiReplaceStr(s,'%2',p2);
    s := AnsiReplaceStr(s,'%3',p3);
    s := AnsiReplaceStr(s,'%4',p4);
    s := AnsiReplaceStr(s,'%5',p5);
    s2 := s;
    Image1.Canvas.Pen.Color := clWhite;
    Image1.Canvas.Rectangle(MT);
    Image1.Canvas.Font.Color := clBlack;
    Image1.Canvas.TextOut(StrToInt(edtTXT2X.text),StrToInt(edtTXT2Y.text),s);
  end;

  if chkTxt3.State = cbChecked then
  begin
    s := s3;
    MT := Rect(StrToInt(edtTXT3X.text),StrToInt(edtTXT3Y.text),StrToInt(edtTXT3X.text)+Image1.Canvas.TextWidth(s),StrToInt(edtTXT3Y.text)+Image1.Canvas.TextHeight(s));
    s := edtTXT3.Text;
    s := AnsiReplaceStr(s,'%1',p1);
    s := AnsiReplaceStr(s,'%2',p2);
    s := AnsiReplaceStr(s,'%3',p3);
    s := AnsiReplaceStr(s,'%4',p4);
    s := AnsiReplaceStr(s,'%5',p5);
    s3 := s;
    Image1.Canvas.Pen.Color := clWhite;
    Image1.Canvas.Rectangle(MT);
    Image1.Canvas.Font.Color := clBlack;
    Image1.Canvas.TextOut(StrToInt(edtTXT3X.text),StrToInt(edtTXT3Y.text),s);
  end;

  if chkTxt4.State = cbChecked then
  begin
    s := s4;
    MT := Rect(StrToInt(edtTXT4X.text),StrToInt(edtTXT4Y.text),StrToInt(edtTXT4X.text)+Image1.Canvas.TextWidth(s),StrToInt(edtTXT4Y.text)+Image1.Canvas.TextHeight(s));
    s := edtTXT4.Text;
    s := AnsiReplaceStr(s,'%1',p1);
    s := AnsiReplaceStr(s,'%2',p2);
    s := AnsiReplaceStr(s,'%3',p3);
    s := AnsiReplaceStr(s,'%4',p4);
    s := AnsiReplaceStr(s,'%5',p5);
    s4 := s;
    Image1.Canvas.Pen.Color := clWhite;
    Image1.Canvas.Rectangle(MT);
    Image1.Canvas.Font.Color := clBlack;
    Image1.Canvas.TextOut(StrToInt(edtTXT4X.text),StrToInt(edtTXT4Y.text),s);
  end;

  if chkTxt5.State = cbChecked then
  begin
    s := s5;
    MT := Rect(StrToInt(edtTXT5X.text),StrToInt(edtTXT5Y.text),StrToInt(edtTXT5X.text)+Image1.Canvas.TextWidth(s),StrToInt(edtTXT5Y.text)+Image1.Canvas.TextHeight(s));
    s := edtTXT5.Text;
    s := AnsiReplaceStr(s,'%1',p1);
    s := AnsiReplaceStr(s,'%2',p2);
    s := AnsiReplaceStr(s,'%3',p3);
    s := AnsiReplaceStr(s,'%4',p4);
    s := AnsiReplaceStr(s,'%5',p5);
    s5 := s;
    Image1.Canvas.Pen.Color := clWhite;
    Image1.Canvas.Rectangle(MT);
    Image1.Canvas.Font.Color := clBlack;
    Image1.Canvas.TextOut(StrToInt(edtTXT5X.text),StrToInt(edtTXT5Y.text),s);
  end;

{  if chkSaveJPG.State = cbChecked then
  begin
    jp := TJPEGImage.Create;
    try
      with jp do
      begin
        CompressionQuality := udJPEGQuality.Position;
        Assign(Image1.Picture.Bitmap);
        SaveToFile('SRG.jpg')
      end;
    finally
      jp.Free;
    end;
  end; }

  CoolTrayIcon1.Hint := FloatToStr(Round((Ldo div 10)/ 10.24)/10) + ' kB/s' + ' / ' + FloatToStr(Round((Lup div 10)/ 10.24)/10) + ' kB/s';

  Ico := TIcon.Create;
  try
    if CoolTrayIcon1.BitmapToIcon(DrawBitmap, Ico, clWhite) then
    begin
      CoolTrayIcon1.Icon.Assign(Ico);
      CoolTrayIcon1.Refresh;
    end;
  finally
    Ico.Free;
  end;

  if chkSaveGIF.State = cbChecked then
  begin
    gf := TGifImage.Create;
    try
      with gf do
      begin
        Assign(Image1.Picture.Bitmap);
        SaveToFile('SRG.gif')
      end;
    finally
      gf.Free;
    end;
  end;

  if not NotFirstVal then NotFirstVal := True;
end;

end.

